// Generated by CoffeeScript 1.12.3
(function() {
  var Component, PropTypes, Provider, connect, createStore, isobject, provider, ref, storeShape,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ref = require('react'), Component = ref.Component, PropTypes = ref.PropTypes;

  provider = null;

  isobject = function(o) {
    return !!o && typeof o === 'object' && !Array.isArray(o);
  };

  createStore = function(state) {
    var dispatch, dispatching, listeners, setState, store, subscribe;
    if (state == null) {
      state = {};
    }
    listeners = [];
    subscribe = function(listener) {
      if (typeof listener !== 'function') {
        throw new Error("Listener must be a function");
      }
      listeners.push(listener);
      return function() {
        var index;
        index = listeners.indexOf(listener);
        if (index < 0) {
          return;
        }
        return listeners.splice(index, 1);
      };
    };
    setState = function(newstate) {
      var prevstate;
      prevstate = state;
      state = newstate;
      return listeners.forEach(function(l) {
        return l(state, prevstate);
      });
    };
    dispatching = false;
    dispatch = function(action) {
      var change, err, k, newstate, newval, v;
      if (typeof action !== 'function') {
        throw new Error("Action must be a function");
      }
      if (dispatching) {
        throw new Error("dispatch in dispatch is not allowed");
      }
      dispatching = true;
      try {
        newval = action(state, dispatch);
        if (newval && typeof newval.then === 'function') {
          dispatching = false;
          return newval.then(function(val) {
            return dispatch(function() {
              return val;
            });
          });
        }
      } catch (error) {
        err = error;
        throw err;
      } finally {
        dispatching = false;
      }
      if (!isobject(newval)) {
        throw new Error("Action must return an object");
      }
      change = false;
      for (k in newval) {
        v = newval[k];
        if (!state.hasOwnProperty(k)) {
          throw new Error("Action returned key (" + k + ") missing in state");
        }
        change |= state[k] !== v;
      }
      if (!change) {
        return state;
      }
      newstate = Object.assign({}, state, newval);
      setState(newstate);
      return newstate;
    };
    store = {
      subscribe: subscribe,
      dispatch: dispatch
    };
    Object.defineProperty(store, 'state', {
      enumerable: true,
      get: function() {
        return state;
      },
      set: function() {
        throw new Error("store.state is read only");
      }
    });
    return store;
  };

  Provider = (function(superClass) {
    extend(Provider, superClass);

    function Provider(props) {
      this.componentWillUnmount = bind(this.componentWillUnmount, this);
      this.componentDidMount = bind(this.componentDidMount, this);
      var ref1, ref2;
      Provider.__super__.constructor.apply(this, arguments);
      if (((ref1 = props.children) != null ? ref1.length : void 0) > 1) {
        throw new Error("Provider does not support multiple children");
      }
      this.store = props.store, this.app = props.app;
      if (((ref2 = props.children) != null ? ref2.length : void 0) === 1) {
        if (this.app) {
          throw new Error('Provider: can\'t set app component both as property and child');
        }
        this.app = props.children[0];
      }
      this.state = props.store.state;
    }

    Provider.prototype.componentDidMount = function() {
      return this.unsubscribe = this.store.subscribe((function(_this) {
        return function(newstate) {
          return _this.setState(newstate);
        };
      })(this));
    };

    Provider.prototype.componentWillUnmount = function() {
      if (typeof this.unsubscribe === "function") {
        this.unsubscribe();
      }
      return this.unsubscribe = null;
    };

    Provider.prototype.render = function() {
      var err;
      provider = this;
      try {
        return this.app();
      } catch (error) {
        err = error;
        throw err;
      } finally {
        (typeof setImmediate !== "undefined" && setImmediate !== null ? setImmediate : setTimeout)((function() {
          return provider = null;
        }), 0);
      }
    };

    return Provider;

  })(Component);

  storeShape = PropTypes.shape({
    subscribe: PropTypes.func.isRequired,
    dispatch: PropTypes.func.isRequired,
    state: PropTypes.object.isRequired
  });

  Provider.propTypes = {
    app: PropTypes.func.isRequired,
    store: storeShape.isRequired
  };

  connect = function(viewfn) {
    if (typeof viewfn !== 'function') {
      throw new Error("connect requires a function argument");
    }
    return function(props) {
      var dispatch, state;
      if (!provider) {
        throw new Error("No provider in scope. View function outside Provider?");
      }
      state = provider.store.state;
      dispatch = provider.store.dispatch;
      return viewfn(state, dispatch, props);
    };
  };

  module.exports = {
    createStore: createStore,
    Provider: Provider,
    connect: connect
  };

}).call(this);

//# sourceMappingURL=refnux.js.map
